<?php 

class Erackerpro_Admin
{

    # name to appear at woo apis
    const APP_NAME = 'Etracker Pro';

    # woo rest api scopes
    const SCOPE = 'read';

    public function __construct()
    {

    }

    public function is_woocommerce_active()
    {
        return class_exists( 'woocommerce' );
    }

    public function authorize_url()
    {
        $authorize_url      = get_site_url() . '/wc-auth/v1/authorize?';
        //set woocommerce authorize params
        $authorize_params   = [
            'app_name' => self::APP_NAME,
            'scope' => self::SCOPE,
            'user_id' => base64_encode(get_site_url()), //as domain
            'return_url' =>  get_site_url() . '/wp-admin/admin.php?page=etrackerpro&action=authorize',
            'callback_url' => ETRACKER_REMOTE_URL . 'woocommerce/authorize',
        ];

        return $authorize_url . http_build_query($authorize_params);
    }

    public function view($file , $data = [])
    {
        extract($data);
        include $this->set_file_path($file);
        exit;
    }

    private function set_file_path($file)
    {
        $fpath =  plugin_dir_path( __FILE__) . "../views/$file.php";

        if(!file_exists($fpath)){
            return plugin_dir_path( __FILE__) . "../views/file_not_found.php";
        }

        return $fpath;
    }

    public function add_or_update_option($option , $value , $deprecated = null, $autoload = 'no') 
    {
        if( get_option( $option ) !== false ) 
        {
            update_option( $option, $value );
        } 
        else 
        {
            add_option( $option, $value, $deprecated, $autoload );
        }
        return;
    }

    public function set_uniqid()
    {
        $uniqid = substr(md5(get_site_url()),0,13);
        $this->add_or_update_option('etracker_uniqid' , $uniqid);
        return $uniqid;
    }

    public function check_domain()
    {
        $response = wp_remote_post( ETRACKER_REMOTE_URL . 'woocommerce/checkdomain', 
        [
            'method' => 'POST',
            'timeout' => 45,
            'redirection' => 5,
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => array(),
            'body' => array( 'user_id' => base64_encode(get_site_url()) ),
            'cookies' => array()
        ]);
        
        $body = wp_remote_retrieve_body( $response );

        return ( $body == 1 ) ? true : false;
        
    }

    public function script_url($uniqid)
    {
        return esc_url( ETRACKER_REMOTE_URL .'tracking/'. $uniqid );
    }

    public function return_setup_url($uniqid)
    {
        return esc_url( ETRACKER_REMOTE_URL .'woocommerce/continue-setup?uniqid='.$uniqid );
    }

    public function redirect_to_authoized()
    {
        $url = get_site_url() . '/wp-admin/admin.php?page=etrackerpro&action=authorize&success=1';
        wp_redirect($url);
        exit;
    }
}

?>